<template>
  <div class="abandonar-barca">
    <div v-if="error" class="error">
      <template v-if="error === 'unprocessable_entity'">
        ¡Ya te fuiste de esta barca!
        <router-link to="/barcas">Volver a las barcas</router-link>
      </template>
      <template v-if="error === 'not_found'">
        Esta barca no existe.
        <router-link to="/barcas">Volver a las barcas</router-link>
      </template>
      <template v-else>
        {{ error }}
      </template>
    </div>
    <h1>
      Abandonar barca
      <template v-if="barca">
        {{ barca.nombre }}
      </template>
    </h1>
    <p>¿Estás segurx de que querés abandonar esta barca?</p>
    <custom-button @click="abandonar" :loading="abandonando">
      Abandonar barca
    </custom-button>
  </div>
</template>

<script>
import { mapState } from 'vuex'
import CustomButton from '@/components/Button.vue'

export default {
  name: 'AbandonarBarca',
  components: { CustomButton },
  data() {
    return { abandonando: false, error: null }
  },
  methods: {
    abandonar() {
      this.abandonando = true
      return this.$store
        .dispatch('abandonarBarca', { barcaId: this.id })
        .then(() => this.$router.push(`/barcas`))
        .catch(err => (this.error = err))
        .finally(() => (this.abandonando = false))
    },
    refrescar() {
      return this.$store.dispatch('conseguirBarca', {
        barcaId: this.id,
      })
    },
  },
  mounted() {
    this.refrescar()
  },
  computed: {
    id() {
      return this.$route.params.id
    },
    ...mapState({
      barca(state) {
        return state.barcas.find(barca => barca.id === Number(this.id))
      },
    }),
  },
}
</script>

<style lang="sass" scoped>
.abandonar-barca
  margin: 10px 20px
</style>
